---
title: Flash video to HTML5 video
slug: Plugins/Flash_to_HTML5/Video
tags:
  - Flash
  - HTML
  - Plugins
  - Video
---
<p class="summary">This resource provides an outline of all the topics you need to know about to convert Flash video to native HTML, plus resources covering all the finer details.</p>

<h2 id="In_a_nutshell">In a nutshell</h2>

<p>HTML5 video is enabled through browser support for video and audio playback, Javascript extensions to control that playback, and ecosystem support for critical functions such as content protection and advertising. </p>

<div class="note">
<p><strong>Note</strong>: Most of the processes described in the below articles talk about video, but audio content works in such a similar way that they are generally applicable to audio too.</p>
</div>

<div class="row topicpage-table">
<div class="section">
<h2 id="Planning">Planning</h2>

<dl>
 <dt><a href="/en-US/docs/Plugins/Flash_to_HTML5/Video/Planning">Planning your transition from Flash video to HTML5 video</a></dt>
 <dd>Transitioning from Flash to HTML can take several months and may require new skills and software. This guide shows you how to plan for that transition, and contains two main parts, <a href="/en-US/docs/Plugins/Flash_to_HTML5/Video/Planning#Auditing_What_You_Have">Content audit</a> and <a href="/en-US/docs/Plugins/Flash_to_HTML5/Video/Planning#Decision_Points">Decision points</a>.</dd>
</dl>

<h2 id="Process">Process</h2>

<dl>
 <dt><a href="/en-US/docs/Plugins/Flash_to_HTML5/Video/Converting_File_Formats">File format conversion</a></dt>
 <dd>Once you've planned out what you want to do, the first step is to convert your video files into formats compatible with HTML embedding.</dd>
 <dt><a href="/en-US/docs/Plugins/Flash_to_HTML5/Video/DRM_and_authentication">DRM and authentication</a></dt>
 <dd>If your media requires authentication/rights to access, you'll need to work out how to hook up the necessary DRM and authentication mechanisms.</dd>
 <dt><a href="/en-US/docs/Plugins/Flash_to_HTML5/Video/Advertising">Video advertising</a></dt>
 <dd>You may also want to incorporate advertising into your video delivery system, via an ad network.</dd>
 <dt><a href="/en-US/docs/Plugins/Flash_to_HTML5/Video/Distribution">Distribution</a></dt>
 <dd>A CDN is a popular choice for effective delivery of media content.</dd>
 <dt><a href="/en-US/docs/Plugins/Flash_to_HTML5/Video/Players">Video and audio players</a></dt>
 <dd>There are a number of ways to play back web media depending on the scale of your needs and whether you need ad integration and digital rights management.</dd>
 <dt><a href="/en-US/docs/Plugins/Flash_to_HTML5/Video/Subtitles_captions">Subtitles and closed captions</a></dt>
 <dd>Just as audio and video may need transcoding for the web, subtitles and closed captions may also need to be converted and made available.</dd>
</dl>
</div>

<div class="section">
<h2 id="API_reference">API reference</h2>

<dl>
 <dt>The {{htmlelement("video")}} and {{htmlelement("audio")}} elements</dt>
 <dd>The basic elements that allow embedding of media into web apps.</dd>
 <dt>{{domxref("HTMLMediaElement")}} API</dt>
 <dd>The <code>HTMLMediaElement</code> API provides all the functionality you'll need for implementing basic media controls, e.g. playing and pausing media, returning the current time elapsed, etc. See also {{domxref("HTMLVideoElement")}} and {{domxref("HTMLAudioElement")}}.</dd>
 <dt><a href="/en-US/docs/Web/API/Encrypted_Media_Extensions_API">Encrypted Media Extensions API</a></dt>
 <dd>The Encrypted Media Extenstions API provides interfaces for controlling the playback of content subject to a digital restrictions management scheme.</dd>
 <dt><a href="/en-US/docs/Web/API/Media_Source_Extensions_API">Media Source Extensions API</a></dt>
 <dd>The Media Source Extensions API (MSE) provides functionality enabling plugin-free web-based streaming media. Using MSE, media streams can be created via JavaScript, and played using <a href="/en-US/docs/Web/HTML/Element/audio" title="The HTML &lt;audio&gt; element is used to embed sound content in documents. It may contain one or more audio sources, represented using the src attribute or the &lt;source&gt; element; the browser will choose the most suitable one. It can also be the destination for streamed media, using a MediaStream."><code>&lt;audio&gt;</code></a> and <a href="/en-US/docs/Web/HTML/Element/video" title="Use the HTML &lt;video&gt; element to embed video content in a document."><code>&lt;video&gt;</code></a> elements.</dd>
 <dt><a href="/en-US/docs/Web/API/Credential_Management_API">Credential Management API</a></dt>
 <dd>The Credential Management API lets a website store and retrieve both user and federated credentials. These capabilities allow users to sign in without typing passwords, see the federated account they used to sign in to a site, and resume a session without the explicit sign-in flow of an expired session.</dd>
</dl>
</div>
</div>

<h2 id="Browser_support">Browser support</h2>

<h3 id="Desktop">Desktop</h3>

<table class="style1">
 <thead>
  <tr>
   <th>Browser</th>
   <th>MSE</th>
   <th> </th>
   <th>EME</th>
   <th> </th>
  </tr>
  <tr>
   <th> </th>
   <th>Browser Version</th>
   <th>Container Supported</th>
   <th>Browser Version</th>
   <th>DRM supported</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>Chrome</td>
   <td>{{CompatChrome(23)}}</td>
   <td>mp4, WebM</td>
   <td>{{CompatChrome(42)}}</td>
   <td>Widevine</td>
  </tr>
  <tr>
   <td>Edge</td>
   <td>All versions</td>
   <td>mp4, m2ts</td>
   <td>All versions</td>
   <td>PlayReady (mp4 only)</td>
  </tr>
  <tr>
   <td>Firefox (Gecko)</td>
   <td>42</td>
   <td>mp4, WebM</td>
   <td>38 (Windows)</td>
   <td>Widevine</td>
  </tr>
  <tr>
   <td>Internet Explorer</td>
   <td>11</td>
   <td>mp4</td>
   <td>11 (Windows 8.1+)</td>
   <td>PlayReady</td>
  </tr>
  <tr>
   <td>Opera</td>
   <td>{{CompatOpera(30)}}</td>
   <td>WebM</td>
   <td>{{CompatOpera(32)}}</td>
   <td>Widevine</td>
  </tr>
  <tr>
   <td>Safari (Webkit)</td>
   <td>OS X Yosemite</td>
   <td>mp4, m2ts</td>
   <td>OS X Yosemite</td>
   <td>FairPlay (m2ts only)</td>
  </tr>
 </tbody>
</table>

<h3 id="Mobile">Mobile</h3>

<table class="style1">
 <thead>
  <tr>
   <th>Browser</th>
   <th>MSE</th>
   <th> </th>
   <th>EME</th>
   <th> </th>
  </tr>
  <tr>
   <th> </th>
   <th>Browser Version</th>
   <th>Container Supported</th>
   <th>Browser Version</th>
   <th>DRM supported</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>Android Webview</td>
   <td>{{CompatNo}}</td>
   <td>{{CompatNo}}</td>
   <td>{{CompatNo}}</td>
   <td>{{CompatNo}}</td>
  </tr>
  <tr>
   <td>Chrome for Android</td>
   <td>{{CompatChrome(30)}}</td>
   <td>mp4, WebM</td>
   <td>{{CompatChrome(42)}}</td>
   <td>Widevine</td>
  </tr>
  <tr>
   <td>Edge Mobile</td>
   <td> </td>
   <td> </td>
   <td> </td>
   <td> </td>
  </tr>
  <tr>
   <td>Firefox Mobile (Gecko)</td>
   <td>41</td>
   <td>mp4, WebM</td>
   <td>{{CompatNo}}</td>
   <td>{{CompatNo}}</td>
  </tr>
  <tr>
   <td>IE Mobile</td>
   <td> </td>
   <td> </td>
   <td> </td>
   <td> </td>
  </tr>
  <tr>
   <td>Opera Mobile</td>
   <td>{{CompatOperaMobile(30)}}</td>
   <td>WebM</td>
   <td>{{CompatNo}}</td>
   <td>{{CompatNo}}</td>
  </tr>
  <tr>
   <td>Safari Mobile</td>
   <td>{{CompatNo}}</td>
   <td>{{CompatNo}}</td>
   <td>{{CompatNo}}</td>
   <td>{{CompatNo}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Getting_help">Getting help</h2>

<p>If you find that our migration guide leaves you with any questions unanswered, please don't hesitate to visit our <a href="https://discourse.mozilla-community.org/c/mdn">MDN Discourse page</a> and ask them there.</p>
